// File: fig0725.cpp
// Computer Systems, Fourth Edition
// Figure 7.25
// A table-lookup parser

#include <iostream>
#include <cctype> // isalpha
#include <string> // string
using namespace std;

enum State {eA, eB, eC};
enum Alphabet {eLETTER, eDIGIT};
State FSM[eC + 1][eDIGIT + 1] = {  // Three rows, two columns
   eB, eC,  // The state transition table of Figure 7.11
   eB, eB,
   eC, eC
};
 
int main () {
   char ch;
   string line;
   Alphabet FSMChar;
   State state = eA;
   cout << "Enter a string of letters and digits: ";
   cin >> line;
   for (int i = 0; i < line.size (); i++) {
      ch = line[i];
      if (isalpha (ch)) {
         FSMChar = eLETTER;
      }
      else {
         FSMChar = eDIGIT;
      }
      state = FSM[state][FSMChar];
   }
   if (state == eB) {
      cout << line << " is a valid identifier." << endl;
   }
   else {
      cout << line << " is not a valid identifier." << endl;
   }
   return 0;
}
