// File: fig0726.cpp
// Computer Systems, Fourth Edition
// Figure 7.26
// A direct-code parser

#include <iostream>
#include <cctype> // isdigit
#include <string> // string, getline
using namespace std;

// Global buffer
string line;
int lineIndex;

void getLine () {
   // Get a line of characters.
   // Install a newline character as sentinel.
   getline (cin, line);
   line.push_back ('\n');
   lineIndex = 0;
}

enum State {eI, eF, eM, eSTOP};

void parseNum (bool& v, int& n) {
   int sign;
   State state;
   char nextChar;
   v = true;
   state = eI;
   do {
      nextChar = line[lineIndex++];
      switch (state) {
         case eI:
            if (nextChar == '+') {
               sign = +1;
               state = eF;
            }
            else if (nextChar == '-') {
               sign = -1;
               state = eF;
            }
            else if (isdigit (nextChar)) {
               sign = +1;
               n = nextChar - '0';
               state = eM;
            }
            else {
               v = false;
            }
            break;
         case eF:
            if (isdigit (nextChar)) {
               n = nextChar - '0';
               state = eM;
            }
            else {
               v = false;
            }
            break;
         case eM:
            if (isdigit (nextChar)) {
               n = 10 * n + nextChar - '0';
            }
            else if (nextChar == '\n') {
               n = sign * n;
               state = eSTOP;
            }
            else {
               v = false;
            }
            break;
      }
   }
   while ((state != eSTOP) && v);
}

int main () {  
   bool valid;
   int num;
   cout << "Enter number: ";
   getLine ();
   parseNum (valid, num);
   if (valid) {
      cout << "Number = " << num << endl;
   }
   else {
      cout << "Invalid entry." << endl;
   }
   return 0;
}

